package net.sf.jasperreports.engine.fill;

class JRLongDistinctCountIncrementer extends JRAbstractExtendedIncrementer {
  private static JRLongDistinctCountIncrementer mainInstance = new JRLongDistinctCountIncrementer();
  
  public static JRLongDistinctCountIncrementer getInstance() {
    return mainInstance;
  }
  
  public Object increment(JRCalculable variable, Object expressionValue, AbstractValueProvider valueProvider) {
    DistinctCountHolder holder = (DistinctCountHolder)valueProvider.getValue(variable.getHelperVariable((byte)0));
    if (variable.isInitialized())
      holder.init(); 
    return new Long(holder.getCount());
  }
  
  public Object combine(JRCalculable calculable, JRCalculable calculableValue, AbstractValueProvider valueProvider) {
    DistinctCountHolder holder = (DistinctCountHolder)valueProvider.getValue(calculable.getHelperVariable((byte)0));
    return new Long(holder.getCount());
  }
  
  public Object initialValue() {
    return JRLongIncrementerFactory.ZERO;
  }
}
